(module simDoorView-module swindle
  
  (provide 
   show-empty-door
   show-person-in-door
   )
  
  (require   
   se3-bib/sim/simBase/sim-base-package
   
   se3-bib/sim/simAppl/simDoorClass-module
   se3-bib/sim/simAppl/simDoorImpl-module  
   
   se3-bib/sim/simAppl/simCustomerClass-module
   se3-bib/sim/simAppl/simCustomerImpl-module
   se3-bib/sim/simAppl/simCustomerView-module  )
  ; show the door
  
  (define *doorWidth* 80)
  (define *doorHeight* 80)
  
  (defmethod show-empty-door ((d sim-door))
    (let ((theIm 
           (overlay
            (rectangle 
             *doorWidth*
             *doorHeight*
             'solid
             'blue)
            (rectangle 
             (- *doorWidth* 16)
             (- *doorHeight* 16)
             'solid
             'black))))
      (set-actor-pic! d theIm)
      theIm))
  
  (defmethod show-person-in-door ((d sim-door))
    (let ((theIm 
           (if (door-empty? d)
               (show-empty-door d)
               (overlay
                (show-empty-door d)
                (actor-picture (theActorInTheDoor d))))))
      (set-actor-pic! d theIm)
      theIm))
  
  (defmethod actor-picture 
    ((d sim-door))
    (show-person-in-door d))  
  
  )