#|
 =================================================================
Module sim-clock-module
          
 provides: - a class simClock
          
 Author: Leonie Dreschler-Fischer         
          
 Version: 0002.0 last changed December 25, 2006 by Leonie Dreschler-Fischer
 =================================================================
|#

(module simClockClass-module 
  swindle
  
  (provide 
   read-sim-clock set-sim-clock!
   
   #|   
   Auto provide: sim-clock
  |#  
   )
  (print "loading: simClockClass-module ")
  (require 
   se3-bib/sim/simBase/sim-utility-base-package
   se3-bib/sim/simBase/simActorClass-module
   )

  
  (defclass* sim-clock (sim-actor)
    (sim-time 
     :reader read-sim-clock
     :writer set-sim-clock!
     :initvalue 0
     :type <number>
     :documentation
     "The simulation time")    
    :autopred #t ; auto generate predicate sim-clock?
    :printer  #t 
    :documentation "The simulation clock"
    )
  
  (defgeneric* clock-info ((clock sim-clock)))
  
  )
