(module mensaScenario2Class-module swindle
  
  
  #|Specialized customer classes and server classes:
    
    vegetarians, servers for vegetarian food,

    auto provide:
      classes:  magic-potion-station  weapons-station
                no-magic-potion-allowed no-weapons-allowed
                foreigner enemy child animal very-strong-person
      generics: reject
    |#
  (provide reject-pic 
           set-reject-pic! 
           )
  (require 
   se3-bib/sim/simAppl/sim-application-package
   se3-bib/sim/simMensa/mensaScenarioClass-module )
  
  #|
 ================================================================
;;; Specialized server stations
 ================================================================
|#
  
  (defclass* mensa-scenario2 
    (mensa-scenario)
    :documentation 
    "A mensa with unfriendly servers"
    :autopred #t ; auto generate predicate sim-scenario?
    :printer  #t 
    )
  
  (defclass* general-food-server (server-station)
    :documentation 
    "A station with restricted access: serving menues with meat")
  
  (defclass* vegetarian-food-server (server-station)
    :documentation 
    "A station with restricted acces: serving menues without meat")
  
  #|
 =================================================================
;;; Specialized customers
 =================================================================
|#
  
  (defclass* vegetarian (customer)
    :documentation
    "Guests who don't like meat")
  )